<template>
  <div>
    <h2>Option - {{o_firstName}}</h2>
    <h2>Option - {{o_firstName}} {{o_lastName}} a.k.a. {{o_heroName}}</h2>
    <h3>Composition - {{c_firstName}}</h3>
    <!-- <h4>{{greet}}</h4> -->
    <h4>Composition - {{c_firstName}} {{c_lastName}} {{c_heroName}}</h4>
    <h4>Composition - {{greetHero}}</h4>
    <h4>Composition - {{reactiveGreetHero}}</h4>
  </div>
</template>

<script>
import { ref, reactive } from "vue";

export default {
  name: "DataComponent",
  //Composition api
  setup() {
    const c_firstName = ref("Clark");
    const c_lastName = ref("Kent");
    const c_heroName = ref("Superman");
    console.log(c_firstName);
   // c_firstName.value = 'Diana';
    const greet = `Hello I'm ${c_firstName.value}` //per scrivere sul leggere o scrivere sul ref bisogna usare il .value
    const greetHero = `Hello ${c_firstName.value} ${c_lastName.value} a.k.a ${c_heroName.value}`
    console.log(c_firstName);

    //reactive data - evitiamo così la ripetizione di ref -
    const state = reactive({
      firstName: 'Princess',
      lastName: 'Diana',
      heroName: 'Wonder Woman',
    })

    const reactiveGreetHero = `Hello ${state.firstName} ${state.lastName} a.k.a. ${state.heroName}`
    return {
      c_firstName,
      c_lastName,
      c_heroName,
      greetHero,
      greet,
      reactiveGreetHero
    };
  },
  //Option api
  data() {
    return {
      o_firstName: "Bruce",
      o_lastName: "Wayne",
      o_heroName: "Batman",
    };
  },
};
</script>

<style>
</style>